

function srovnani
%GUI pro vyuku makroekonomickho modelovn
clear all
close all



%Main
f1h=figure('Name','Srovnn vlivu parametr','NumberTitle','off',...
    'Position',[100 100 1220 600],'Resize','off','MenuBar','none',...
    'Units','pixels','Visible','off');

bg = get(0,'defaultUicontrolBackgroundColor');
set(f1h,'Color',bg);

%Menu
eh1 = uimenu(f1h,'Label','Vrtit hodnoty pvodnch parametr','Callback',{@eh1_callback});
eh12 = uimenu(f1h,'Label','                                                                                    ');
eh2 = uimenu(f1h,'Label','Vrtit hodnoty novch parametr','Callback',{@eh2_callback});
%Panels

p2h = uipanel('Parent',f1h,'Title','Pvodn dynamick IS kivka',...
    'Position',[.22 .67 .27 .33]);
p22h = uipanel('Parent',f1h,'Title','Pvodn Phillipsova kivka',...
    'Position',[.22 .34 .27 .33]);
p23h = uipanel('Parent',f1h,'Title','Pvodn monetrn pravidlo',...
    'Position',[.22 .01 .27 .33]);

p3h = uipanel('Parent',f1h,'Title','Nov dynamick IS kivka',...
    'Position',[.72 .67 .27 .33]);
p32h = uipanel('Parent',f1h,'Title','Nov Phillipsova kivka',...
    'Position',[.72 .34 .27 .33]);
p33h = uipanel('Parent',f1h,'Title','Nov monetrn pravidlo',...
    'Position',[.72 .01 .27 .33]);

p4h = uipanel('Parent',f1h,'Title','Pvodn parametry',...
    'Position',[.01 .62 .2 .38]);
p5h = uipanel('Parent',f1h,'Title','oky',...
    'Position',[.01 .01 .2 .6]);

p42h = uipanel('Parent',f1h,'Title','Nov parametry',...
    'Position',[.51 .62 .2 .38]);
p52h = uipanel('Parent',f1h,'Title','oky',...
    'Position',[.51 .01 .2 .6]);

%Axes

ah = axes('Parent',p2h,'Position',[.1 .12 .8 .8]);
ah2 = axes('Parent',p22h,'Position',[.1 .12 .8 .8]);
ah3 = axes('Parent',p23h,'Position',[.1 .12 .8 .8]);

ah4 = axes('Parent',p3h,'Position',[.1 .12 .8 .8]);
ah5 = axes('Parent',p32h,'Position',[.1 .12 .8 .8]);
ah6 = axes('Parent',p33h,'Position',[.1 .12 .8 .8]);


%Static Text

sth1 = uicontrol(p4h,'Style','text','String','alpha:','Position',[10 180 40 20]);
sth2 = uicontrol(p4h,'Style','text','String','beta:','Position',[10 150 40 20]);
sth3 = uicontrol(p4h,'Style','text','String','gamma:','Position',[10 120 40 20]);
sth4 = uicontrol(p4h,'Style','text', 'String','delta:', 'Position',[10 90 40 20]);
sth5 = uicontrol(p4h,'Style','text', 'String','lamda:', 'Position',[10 60 40 20]);
sth6 = uicontrol(p4h,'Style','text', 'String','kappa:', 'Position',[10 30 40 20]);
sth7 = uicontrol(p4h,'Style','text','String','z intervalu (0,1]', 'Position',[120 180 100 20]);
sth8 = uicontrol(p4h,'Style','text','String','zporn','Position',[120 150 100 20]);
sth9 = uicontrol(p4h,'Style','text','String','z intervalu (0,1]','Position',[120 120 100 20]);
sth10 = uicontrol(p4h,'Style','text','String','kladn','Position',[120 90 100 20]);
sth11 = uicontrol(p4h,'Style','text','String','kladn','Position',[120 60 100 20]);
sth12 = uicontrol(p4h,'Style','text','String','vt jak 1','Position',[120 30 100 20]);
sth13 = uicontrol(p5h,'Style','text','String','1. obdob','Position',[70  250  100  20]);
sth14 = uicontrol(p5h,'Style','text','String','1. obdob','Position',[70  160  100  20],'Enable','off');
sth15 = uicontrol(p5h,'Style','text','String','1. obdob','Position',[70  70  100  20],'Enable','off');

sth21 = uicontrol(p42h,'Style','text','String','alpha:','Position',[10 180 40 20]);
sth22 = uicontrol(p42h,'Style','text','String','beta:','Position',[10 150 40 20]);
sth23 = uicontrol(p42h,'Style','text','String','gamma:','Position',[10 120 40 20]);
sth24 = uicontrol(p42h,'Style','text', 'String','delta:', 'Position',[10 90 40 20]);
sth25 = uicontrol(p42h,'Style','text', 'String','lamda:', 'Position',[10 60 40 20]);
sth26 = uicontrol(p42h,'Style','text', 'String','kappa:', 'Position',[10 30 40 20]);
sth27 = uicontrol(p42h,'Style','text','String','z intervalu (0,1]', 'Position',[120 180 100 20]);
sth28 = uicontrol(p42h,'Style','text','String','zporn','Position',[120 150 100 20]);
sth29 = uicontrol(p42h,'Style','text','String','z intervalu (0,1]','Position',[120 120 100 20]);
sth210 = uicontrol(p42h,'Style','text','String','kladn','Position',[120 90 100 20]);
sth211 = uicontrol(p42h,'Style','text','String','kladn','Position',[120 60 100 20]);
sth212 = uicontrol(p42h,'Style','text','String','vt jak 1','Position',[120 30 100 20]);
sth213 = uicontrol(p52h,'Style','text','String','1. obdob','Position',[70  250  100  20]);
sth214 = uicontrol(p52h,'Style','text','String','1. obdob','Position',[70  160  100  20],'Enable','off');
sth215 = uicontrol(p52h,'Style','text','String','1. obdob','Position',[70  70  100  20],'Enable','off');
%Edit text

eth1 = uicontrol(p4h,'Style','edit','String','0.8','Position',[60 180 50 20]);
eth2 = uicontrol(p4h,'Style','edit','String','-0.6','Position',[60 150 50 20]);
eth3 = uicontrol(p4h,'Style','edit','String','0.5','Position',[60 120 50 20]);
eth4 = uicontrol(p4h,'Style','edit','String','0.3','Position',[60 90 50 20]);
eth5 = uicontrol(p4h,'Style','edit','String','0.5','Position',[60 60 50 20]);
eth6 = uicontrol(p4h,'Style','edit','String','1.5','Position',[60 30 50 20]);

eth21 = uicontrol(p42h,'Style','edit','String','0.8','Position',[60 180 50 20]);
eth22 = uicontrol(p42h,'Style','edit','String','-0.6','Position',[60 150 50 20]);
eth23 = uicontrol(p42h,'Style','edit','String','0.5','Position',[60 120 50 20]);
eth24 = uicontrol(p42h,'Style','edit','String','0.3','Position',[60 90 50 20]);
eth25 = uicontrol(p42h,'Style','edit','String','0.5','Position',[60 60 50 20]);
eth26 = uicontrol(p42h,'Style','edit','String','1.5','Position',[60 30 50 20]);
%Pop-up menu
pmh1 = uicontrol('Parent',p5h,'Style','popupmenu',...
    'String',{'Poptvkov ok','Nabdkov ok','Monetrn ok'},...
    'Value',1,'Position',[70 310 160 20]);
pmh2 = uicontrol('Parent',p5h,'Style','popupmenu',...
    'String',{'Poptvkov ok','Nabdkov ok','Monetrn ok'},...
    'Value',1,'Position',[70 220 160 20],'Enable','off');
pmh3 = uicontrol('Parent',p5h,'Style','popupmenu',...
    'String',{'Poptvkov ok','Nabdkov ok','Monetrn ok'},...
    'Value',1,'Position',[70 130 160 20],'Enable','off');

pmh21 = uicontrol('Parent',p52h,'Style','popupmenu',...
    'String',{'Poptvkov ok','Nabdkov ok','Monetrn ok'},...
    'Value',1,'Position',[70 310 160 20]);
pmh22 = uicontrol('Parent',p52h,'Style','popupmenu',...
    'String',{'Poptvkov ok','Nabdkov ok','Monetrn ok'},...
    'Value',1,'Position',[70 220 160 20],'Enable','off');
pmh23 = uicontrol('Parent',p52h,'Style','popupmenu',...
    'String',{'Poptvkov ok','Nabdkov ok','Monetrn ok'},...
    'Value',1,'Position',[70 130 160 20],'Enable','off');
%Checkbox
cbh1 = uicontrol('Parent',p5h,'Style','checkbox',...
    'String','1. ok',...
    'Value',1,'Position',[5 308 60 20],'Callback',{@callback_cbh1});
cbh2 = uicontrol('Parent',p5h,'Style','checkbox',...
    'String','2. ok',...
    'Value',0,'Position',[5 218 60 20],'Callback',{@callback_cbh2});
cbh3 = uicontrol('Parent',p5h,'Style','checkbox',...
    'String','3. ok',...
    'Value',0,'Position',[5 128 60 20],'Callback',{@callback_cbh3});

cbh21 = uicontrol('Parent',p52h,'Style','checkbox',...
    'String','1. ok',...
    'Value',1,'Position',[5 308 60 20],'Callback',{@callback_cbh21});
cbh22 = uicontrol('Parent',p52h,'Style','checkbox',...
    'String','2. ok',...
    'Value',0,'Position',[5 218 60 20],'Callback',{@callback_cbh22});
cbh23 = uicontrol('Parent',p52h,'Style','checkbox',...
    'String','3. ok',...
    'Value',0,'Position',[5 128 60 20],'Callback',{@callback_cbh23});

%Slider
sh1 = uicontrol('Parent',p5h,'Style','slider',...
    'Max',15,'Min',1,'Value',1,...
    'SliderStep',[1/14 1/14],...
    'Position',[5  275  225  20],'Callback',{@callback_slider});
sh2 = uicontrol('Parent',p5h,'Style','slider',...
    'Max',15,'Min',1,'Value',1,...
    'SliderStep',[1/14 1/14],...
    'Position',[5  185  225  20],'Callback',{@callback_slider2},'Enable','off');
sh3 = uicontrol('Parent',p5h,'Style','slider',...
    'Max',15,'Min',1,'Value',1,...
    'SliderStep',[1/14 1/14],...
    'Position',[5  95  225  20],'Callback',{@callback_slider3},'Enable','off');

sh21 = uicontrol('Parent',p52h,'Style','slider',...
    'Max',15,'Min',1,'Value',1,...
    'SliderStep',[1/14 1/14],...
    'Position',[5  275  225  20],'Callback',{@callback_slider21});
sh22 = uicontrol('Parent',p52h,'Style','slider',...
    'Max',15,'Min',1,'Value',1,...
    'SliderStep',[1/14 1/14],...
    'Position',[5  185  225  20],'Callback',{@callback_slider22},'Enable','off');
sh23 = uicontrol('Parent',p52h,'Style','slider',...
    'Max',15,'Min',1,'Value',1,...
    'SliderStep',[1/14 1/14],...
    'Position',[5  95  225  20],'Callback',{@callback_slider23},'Enable','off');


%Push button
pbh = uicontrol('Parent',p5h,'Style','pushbutton','String','Spustit',...
    'Position',[20 5 200 60],'Callback',{@callback_button});

pbh2 = uicontrol('Parent',p52h,'Style','pushbutton','String','Spustit',...
    'Position',[20 5 200 60],'Callback',{@callback_button2});


%Callbacks

    function callback_slider(~,~)
        set(sth13,'String',[num2str(ceil(get(sh1,'Value'))) '. obdob']);
    end

    function callback_slider2(~,~)
        set(sth14,'String',[num2str(ceil(get(sh2,'Value'))) '. obdob']);
    end

    function callback_slider3(~,~)
        set(sth15,'String',[num2str(ceil(get(sh3,'Value'))) '. obdob']);
    end

    function callback_slider21(~,~)
        set(sth213,'String',[num2str(ceil(get(sh21,'Value'))) '. obdob']);
    end

    function callback_slider22(~,~)
        set(sth214,'String',[num2str(ceil(get(sh22,'Value'))) '. obdob']);
    end

    function callback_slider23(~,~)
        set(sth215,'String',[num2str(ceil(get(sh23,'Value'))) '. obdob']);
    end

    function callback_cbh1(~,~)
        if (get(cbh1,'Value') == 1)
            set([sth13 pmh1 sh1],'Enable', 'on');
        else
            set([sth13 pmh1 sh1],'Enable', 'off');
        end
    end

    function callback_cbh2(~,~)
        if (get(cbh2,'Value') == 1)
            set([sth14 pmh2 sh2],'Enable', 'on');
        else
            set([sth14 pmh2 sh2],'Enable', 'off');
        end
    end

    function callback_cbh3(~,~)
        if (get(cbh3,'Value') == 1)
            set([sth15 pmh3 sh3],'Enable', 'on');
        else
            set([sth15 pmh3 sh3],'Enable', 'off');
        end
    end

    function callback_cbh21(~,~)
        if (get(cbh21,'Value') == 1)
            set([sth213 pmh21 sh21],'Enable', 'on');
        else
            set([sth213 pmh21 sh21],'Enable', 'off');
        end
    end

    function callback_cbh22(~,~)
        if (get(cbh22,'Value') == 1)
            set([sth214 pmh22 sh22],'Enable', 'on');
        else
            set([sth214 pmh22 sh22],'Enable', 'off');
        end
    end

    function callback_cbh23(~,~)
        if (get(cbh23,'Value') == 1)
            set([sth215 pmh23 sh23],'Enable', 'on');
        else
            set([sth215 pmh23 sh23],'Enable', 'off');
        end
    end


    function eh1_callback(~,~)
        
        
        set(eth1,'String','0.8');
        set(eth2,'String','-0.6');
        set(eth3,'String','0.5');
        set(eth4,'String','0.3');
        set(eth5,'String','0.5');
        set(eth6,'String','1.5');
        
        set(pmh1,'Value',1,'Enable','on');
        set(pmh2,'Value',1,'Enable','off');
        set(pmh3,'Value',1,'Enable','off');
        
        set(sh1,'Value',1,'Enable','on');
        set(sh2,'Value',1,'Enable','off');
        set(sh3,'Value',1,'Enable','off');
        
        set(cbh1,'Value',1);
        set(cbh2,'Value',0);
        set(cbh3,'Value',0);
        
        
        set(sth13,'String',[num2str(get(sh1,'Value')) '. obdob'],'Enable','on');
        set(sth14,'String',[num2str(get(sh1,'Value')) '. obdob'],'Enable','off');
        set(sth15,'String',[num2str(get(sh1,'Value')) '. obdob'],'Enable','off');
        
    end

    function eh2_callback(~,~)
        
        
        set(eth21,'String','0.8');
        set(eth22,'String','-0.6');
        set(eth23,'String','0.5');
        set(eth24,'String','0.3');
        set(eth25,'String','0.5');
        set(eth26,'String','1.5');
        
        set(pmh21,'Value',1,'Enable','on');
        set(pmh22,'Value',1,'Enable','off');
        set(pmh23,'Value',1,'Enable','off');
        
        set(sh21,'Value',1,'Enable','on');
        set(sh22,'Value',1,'Enable','off');
        set(sh23,'Value',1,'Enable','off');
        
        set(cbh21,'Value',1);
        set(cbh22,'Value',0);
        set(cbh23,'Value',0);
        
        
        set(sth213,'String',[num2str(get(sh21,'Value')) '. obdob'],'Enable','on');
        set(sth214,'String',[num2str(get(sh21,'Value')) '. obdob'],'Enable','off');
        set(sth215,'String',[num2str(get(sh21,'Value')) '. obdob'],'Enable','off');
        
    end



    function callback_button(~,~)
        
        set(0,'defaultlinelinewidth',1.5);
        
        %parametry
        error = '';
        
        a = strrep(get(eth1,'String'),',','.');
        if or(str2double(a)<=0, str2double(a)>1)
            error = char(error,'Zadejte parametr alpha z intervalu (0,1].');
        else
            alpha = str2double(a);     % (0,1]
        end
        
        b = strrep(get(eth2,'String'),',','.');
        if (str2double(b)>=0)
            error = char(error,'Zadejte parametr beta mensi nez 0.');
        else
            beta = str2double(b);   %zaporna
        end
        
        c = strrep(get(eth3,'String'),',','.');
        if or(str2double(c)<=0, str2double(c)>1)
            error = char(error,'Zadejte parametr gamma z intervalu (0,1].');
        else
            gamma = str2double(c);     % (0,1]
        end
        
        d = strrep(get(eth4,'String'),',','.');
        if (str2double(d)<=0)
            error =char(error,'Zadejte parametr delta vetsi nez 0.');
        else
            delta = str2double(d);     % kladna
        end
        
        l = strrep(get(eth5,'String'),',','.');
        if (str2double(l)<=0)
            error = char(error,'Zadejte parametr lambda vetsi nez 0.');
        else
            lambda = str2double(l);     % kladna
        end
        
        k = strrep(get(eth6,'String'),',','.');
        if (str2double(k)<=1)
            error = char(error,'Zadejte parametr kappa vetsi nez 1.');
        else
            kappa = str2double(k);     % vetsi nez 1
        end
        if (~isempty(error))
            warndlg(error)
        else
            
            
            m.A = [1    0   beta  -beta
                -delta  1   -(1-gamma)     0
                -lambda  -kappa  0     1
                0    1     0       0  ];
            
            m.B = [  alpha   0   0   0
                0    gamma  0   0
                0     0   0   0
                0     0   1   0];
            
            m.C = [1  0  0
                0  1  0
                0  0  1
                0  0  0];
            
            m.prows=[1 2 4]; % predeterminovane radky, jejichz hodnotu v case t zname
            
            m = matice(m);  %nacte matice
            e = zeros(3,15);  %preddefinovani vektoru soku
            
            if (get(cbh1,'Value') == 1)
                e(get(pmh1,'Value'),ceil(get(sh1,'Value'))) = 1;         %  poptavkovy 1, nabidkovy 2, monetarni 3, sok v 1. obdobi,
            end
            
            if (get(cbh2,'Value') == 1)
                e(get(pmh2,'Value'),ceil(get(sh2,'Value'))) = 1;         %  poptavkovy 1, nabidkovy 2, monetarni 3, sok v 1. obdobi,
            end
            
            if (get(cbh3,'Value') == 1)
                e(get(pmh3,'Value'),ceil(get(sh3,'Value'))) = 1;         %  poptavkovy 1, nabidkovy 2, monetarni 3, sok v 1. obdobi,
            end
            
            x=reseni(m,e); %reseni
            ymax = max(max(max(x(:,1)),max(x(:,2))),max(x(:,4)));
            ymin = min(min(min(x(:,1)),min(x(:,2))),min(x(:,4)));
            
            
            
            plot(ah,x(1:end,1),'*-')
            legend(ah,'vstup')
            plot(ah2,x(1:end,2),'g*-')
            legend(ah2,'inflace')
            plot(ah3,x(1:end,4),'r*-')
            legend(ah3,'rokov mra')
             
            ylim(ah, [ymin ymax])
            ylim(ah2, [ymin ymax])
            ylim(ah3, [ymin ymax])
            grid(ah)
            grid(ah2)
            grid(ah3)
            
        end
    end

    function callback_button2(~,~)
        
        set(0,'defaultlinelinewidth',1.5);
        
        %parametry
        error = '';
        
        a = strrep(get(eth21,'String'),',','.');
        if or(str2double(a)<=0, str2double(a)>1)
            error = char(error,'Zadejte parametr alpha z intervalu (0,1].');
        else
            alpha = str2double(a);     % (0,1]
        end
        
        b = strrep(get(eth22,'String'),',','.');
        if (str2double(b)>=0)
            error = char(error,'Zadejte parametr beta mensi nez 0.');
        else
            beta = str2double(b);   %zaporna
        end
        
        c = strrep(get(eth23,'String'),',','.');
        if or(str2double(c)<=0, str2double(c)>1)
            error = char(error,'Zadejte parametr gamma z intervalu (0,1].');
        else
            gamma = str2double(c);     % (0,1]
        end
        
        d = strrep(get(eth24,'String'),',','.');
        if (str2double(d)<=0)
            error =char(error,'Zadejte parametr delta vetsi nez 0.');
        else
            delta = str2double(d);     % kladna
        end
        
        l = strrep(get(eth25,'String'),',','.');
        if (str2double(l)<=0)
            error = char(error,'Zadejte parametr lambda vetsi nez 0.');
        else
            lambda = str2double(l);     % kladna
        end
        
        k = strrep(get(eth26,'String'),',','.');
        if (str2double(k)<=1)
            error = char(error,'Zadejte parametr kappa vetsi nez 1.');
        else
            kappa = str2double(k);     % vetsi nez 1
        end
        if (~isempty(error))
            warndlg(error)
        else
            
            
            m.A = [1    0   beta  -beta
                -delta  1   -(1-gamma)     0
                -lambda  -kappa  0     1
                0    1     0       0  ];
            
            m.B = [  alpha   0   0   0
                0    gamma  0   0
                0     0   0   0
                0     0   1   0];
            
            m.C = [1  0  0
                0  1  0
                0  0  1
                0  0  0];
            
            m.prows=[1 2 4]; % predeterminovane radky, jejichz hodnotu v case t zname
            
            m = matice(m);  %nacte matice
            e = zeros(3,15);  %preddefinovani vektoru soku
            
            if (get(cbh21,'Value') == 1)
                e(get(pmh21,'Value'),ceil(get(sh21,'Value'))) = 1;         %  poptavkovy 1, nabidkovy 2, monetarni 3, sok v 1. obdobi,
            end
            
            if (get(cbh22,'Value') == 1)
                e(get(pmh22,'Value'),ceil(get(sh22,'Value'))) = 1;         %  poptavkovy 1, nabidkovy 2, monetarni 3, sok v 1. obdobi,
            end
            
            if (get(cbh23,'Value') == 1)
                e(get(pmh23,'Value'),ceil(get(sh23,'Value'))) = 1;         %  poptavkovy 1, nabidkovy 2, monetarni 3, sok v 1. obdobi,
            end
            grid
            x=reseni(m,e); %reseni
            
            ymax = max(max(max(x(:,1)),max(x(:,2))),max(x(:,4)));
            ymin = min(min(min(x(:,1)),min(x(:,2))),min(x(:,4)));
            
   
            
            plot(ah4,x(1:end,1),'*-')
            legend(ah4,'vstup')
            plot(ah5,x(1:end,2),'g*-')
            legend(ah5,'inflace')
            plot(ah6,x(1:end,4),'r*-')
            legend(ah6,'rokov mra')
             
            ylim(ah4, [ymin ymax])
            ylim(ah5, [ymin ymax])
            ylim(ah6, [ymin ymax])
            
            grid(ah4)
            grid(ah5)
            grid(ah6)
        end
    end



xlim(ah,[1 15])
xlim(ah2,[1 15])
xlim(ah3,[1 15])
xlim(ah4,[1 15])
xlim(ah5,[1 15])
xlim(ah6,[1 15])

grid(ah)
grid(ah2)
grid(ah3)
grid(ah4)
grid(ah5)
grid(ah6)
set(f1h,'Visible','on');


end