function m=matice(m)

[p,n]=size(m.A);  % p ... pocet rovnic, n ... pocet promennych

BB = inv(m.A) * m.B;      %vypocet matic
CC = inv(m.A) * m.C;

[P, V] = eig(BB);         %vypocet matice vl. cisel V  a  matice vl. vektoru P

[aux, ix] = sort(abs(diag(V)));  %serazeni
V = V(ix, ix);            %serazeni stabilni | nestabilni cast
P = P(:, ix);

ns = length(find(abs(diag(V))) <= 1);   %(1+eps^(1/4))));  %najde pocet stabilnich vl. cisel 
nu = n-ns;                                 %pocet nestabilnich vl. cisel     

m.bk = ns == length(m.prows);              %pokud je splnena b-k podminka = 1, jinak = 0

W = inv(P)*CC;           %matice prislusna nahodne slozce

V11 = V(1:ns, 1:ns);     %stabilni vl. cisla
W1  = W(1:ns, :);        %stabilni cast matice W

V22 = V(ns+1:end, ns+1:end);   %nestabilni vl. cisla
W2  = W(ns+1:end, :);

m.ns=ns;
m.V=V;
m.P=P;
m.V11=V11;
m.W1=W1;
m.V22=V22;
m.W2=W2;


